<?php
namespace App\Tests\Controller;

use App\Controller\HelloController;
use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;

class HelloControllerTest extends WebTestCase
{
  public function testHelloRandomRoute()
  {
    $client = static::createClient();

    $crawler = $client->request("GET", "/helloRandom");

    $this->assertEquals(200, $client->getResponse()->getStatusCode());
    $this->assertStringContainsString("Hello ", $crawler->filter("h1")->text());
  }

  function testRandomNameGenerator()
  {
    $rdName = HelloController::generateRandomName();
    $this->assertGreaterThan(1, strlen($rdName));
  }
  
  function testNameAction()
  {
    $dumbledore = "Albus Perceval Wulfric Brian Dumbledore";
    
    $client = static::createClient();
    
    $crawler1 = $client->request("GET", "/hello");
    $crawler2 = $client->request("GET", "/hello");
    $crawler3 = $client->request("GET", "/hello/".$dumbledore);
    
    $this->assertEquals(200, $client->getResponse()->getStatusCode());
    
    $randomName = $crawler1->filter("h1")->text();
    
    $this->assertGreaterThan(strlen("Hello "), strlen($randomName));
    $this->assertEquals($randomName, $crawler2->filter("h1")->text());
    $this->assertStringContainsString($dumbledore, $crawler3->filter("h1")->text());
  }
}
